#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "QUANTA/QUANTAinit.hxx"
#include "QUANTA/QUANTAts_thread_c.hxx"

#define CYCLES 10
static int count = 0;

void* threadFunc(void* data)
{
	int threadIndex = (int)data;
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread %d cycle i = %d global count = %d\n", threadIndex, i, count);
		count++;

		Sleep(500); // window Sleep
	}

	return NULL;
}

void* threadFunc1(void* data)
{
	int threadIndex = 1;
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread %d cycle i = %d global count = %d\n", threadIndex, i, count);
		count++;

		Sleep(500); // window Sleep
	}

	return NULL;
}

void* threadFunc2(void* data)
{
	int threadIndex = 2;
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread %d cycle i = %d global count = %d\n", threadIndex, i, count);
		count++;

		Sleep(500); // window Sleep
	}

	return NULL;
}

void* threadFunc3(void* data)
{
	int threadIndex = 3;
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread %d cycle i = %d global count = %d\n", threadIndex, i, count);
		count++;

		Sleep(500); // window Sleep
	}

	return NULL;
}

int main(int argc, char** argv)
{
	QUANTAinit();
	QUANTAts_thread_c thread;

	//thread.create(threadFunc1, NULL);
	//thread.create(threadFunc2, NULL);
	//thread.create(threadFunc3, NULL);
	int index = 1;
	thread.create(threadFunc, (void *)index);
	index = 2;
	thread.create(threadFunc, (void *)index);
	index = 3;
	thread.create(threadFunc, (void *)index);

	for (int i = 0; i < 2* CYCLES; i++)
	{
		printf("main cycle i = %d\n", i);
		Sleep(500); // window Sleep
	}

	return 0;
}